import _extends from "@babel/runtime/helpers/esm/extends";
import partial from 'lodash.partial';
import { query } from './query';
import { withAdapter } from './with-adapter';
import { withEncryption } from './with-encryption';

// FIXME: deprecated
var makeDeprecatedResolverMap = function makeDeprecatedResolverMap(readModel, bindResolver) {
  return Object.keys(readModel.resolvers).reduce(function (map, name) {
    map[name] = function (args) {
      // eslint-disable-next-line no-console
      console.warn("Direct resolver selector deprecated, you should use 'query' selector with arguments instead.");
      return bindResolver(name, args);
    };

    return map;
  }, {});
};

export var readModel = function readModel(givenEventsContext, _readModel) {
  var context = _extends({}, givenEventsContext, {
    readModel: _readModel
  }); // FIXME: deprecated


  if (_readModel.adapter != null) {
    // eslint-disable-next-line no-console
    console.warn("'adapter' property of read model deprecated, use 'withAdapter' selector instead.");
    withAdapter(context, _readModel.adapter);
  } // FIXME: deprecated


  if (_readModel.encryption != null) {
    // eslint-disable-next-line no-console
    console.warn("'encryption' property of read model deprecated, use 'withEncryption' selector instead.");
    withEncryption(context, _readModel.encryption);
  }

  return _extends({
    query: partial(query, context),
    withAdapter: partial(withAdapter, context),
    withEncryption: partial(withEncryption, context),
    then: function then() {
      throw Error("Incomplete BDD test configuration! Please, provide a query.");
    }
  }, makeDeprecatedResolverMap(_readModel, partial(query, context)));
};
//# sourceMappingURL=read-model.js.map