"use strict";

exports.__esModule = true;
exports.getQueryImplementationKey = exports.getCommandImplementationKey = void 0;

var getCommandImplementationKey = function getCommandImplementationKey(_ref) {
  var type = _ref.type,
      aggregateName = _ref.aggregateName;
  return aggregateName + ":" + type;
};

exports.getCommandImplementationKey = getCommandImplementationKey;

var getQueryImplementationKey = function getQueryImplementationKey(_ref2) {
  var modelName = _ref2.modelName,
      resolverName = _ref2.resolverName;
  return modelName + ":" + resolverName;
};

exports.getQueryImplementationKey = getQueryImplementationKey;
//# sourceMappingURL=utils.js.map